/*
 * Copyright (c) 2013 - 2015, Freescale Semiconductor, Inc.
 * Copyright 2016-2017 NXP
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

#include "fsl_device_registers.h"
#include "fsl_debug_console.h"
#include "fsl_iomuxc.h"
#include "board.h"

#include "pin_mux.h"
#include "clock_config.h"

#include "ramfunc.hpp"
/*******************************************************************************
 * Definitions
 ******************************************************************************/


/*******************************************************************************
 * Prototypes
 ******************************************************************************/

/*******************************************************************************
 * Code
 ******************************************************************************/
/*!
 * @brief Main function
 */
int main(void)
{
    /* Init board hardware. */
    BOARD_ConfigMPU();
    BOARD_InitPins();
    BOARD_BootClockRUN();
    BOARD_InitDebugConsole();

    {
        CLOCK_EnableClock(kCLOCK_Iomuxc);           /* iomuxc clock (iomuxc_clk_enable): 0x03U */

        IOMUXC_SetPinMux(
            IOMUXC_GPIO_AD_B0_06_JTAG_TMS,          /* GPIO_AD_B0_06 is configured as JTAG_TMS */
            0U);                                    /* Software Input On Field: Input Path is determined by functionality */
        IOMUXC_SetPinMux(
            IOMUXC_GPIO_AD_B0_07_JTAG_TCK,          /* GPIO_AD_B0_07 is configured as JTAG_TCK */
            0U);                                    /* Software Input On Field: Input Path is determined by functionality */
        IOMUXC_SetPinMux(
            IOMUXC_GPIO_AD_B0_10_ARM_TRACE_SWO,     /* GPIO_AD_B0_10 is configured as ARM_TRACE_SWO */
            0U);                                    /* Software Input On Field: Input Path is determined by functionality */
    }
    {
        CLOCK_InitSysPfd(kCLOCK_Pfd1, 16);
        CLOCK_SetDiv(kCLOCK_TraceDiv, 0);
        CLOCK_SetMux(kCLOCK_TraceMux, 3);
        CLOCK_EnableClock(kCLOCK_Trace);
        *(reinterpret_cast<uint32_t*>(0x400E0600)) = (1 << 11); // enable TPIU clock -  PMC_SCER = PMC_SCER_PCK3
    }

    PRINTF("hello world.\r\n");

    ramfunc();
}
